Index: loader/source/menu.c
===================================================================
--- loader/source/menu.c	(revision 542)
+++ loader/source/menu.c	(working copy)
@@ -824,59 +998,99 @@
 					if ( VideoModeVal < VideoTestVal )
 					{
 						ncfg->VideoMode &= ~NIN_VID_FORCE_MASK;
-						ncfg->VideoMode |= NIN_VID_FORCE_NTSC;
-						VideoModeIndex = NIN_VID_INDEX_FORCE_NTSC;
-					}
-					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+50, SettingY(ListLoopIndex),"%-18s:%-5s", OptionStrings[ListLoopIndex], VideoModeStrings[VideoModeIndex] );
-				}
-				ListLoopIndex++;
-
+						ncfg->VideoMode |= NIN_VID_FORCE_NTSC;
+						VideoModeIndex = NIN_VID_INDEX_FORCE_NTSC;
+					}
+					if (which_bg == BG_NONE)
+					{
+PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+50, SettingY(ListLoopIndex),"%-18s:%-5s", OptionStrings[ListLoopIndex], VideoModeStrings[VideoModeIndex] );
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+PrintFormat(MENU_SIZE, WHITE, MENU_POS_X+50, SettingY(ListLoopIndex),"%-18s:%-5s", OptionStrings[ListLoopIndex], VideoModeStrings[VideoModeIndex] );
+					}
+				}
+				ListLoopIndex++;
+
 				if ((ncfg->Config & NIN_CFG_MEMCARDEMU) == NIN_CFG_MEMCARDEMU)
 				{
-					u32 MemCardBlocksVal = ncfg->MemCardBlocks;
-					if (MemCardBlocksVal > MEM_CARD_MAX)
-						MemCardBlocksVal = 0;
-					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 50, SettingY(ListLoopIndex), "%-18s:%-4d%s", OptionStrings[ListLoopIndex], MEM_CARD_BLOCKS(MemCardBlocksVal), MemCardBlocksVal > 2 ? "Unstable" : "");
-					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 50, SettingY(ListLoopIndex+1), "%-18s:%-4s", OptionStrings[ListLoopIndex+1], (ncfg->Config & (NIN_CFG_MC_MULTI)) ? "On " : "Off");
-				}
-				ListLoopIndex+=2;
-
-				PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 50, SettingY(ListLoopIndex), "%-18s:%-4s", OptionStrings[ListLoopIndex], (ncfg->Config & (NIN_CFG_NATIVE_SI)) ? "On " : "Off");
-				ListLoopIndex++;
-
-				char vidWidth[10];
-				if(ncfg->VideoScale < 40 || ncfg->VideoScale > 120)
-				{
+					u32 MemCardBlocksVal = ncfg->MemCardBlocks;
+					if (MemCardBlocksVal > MEM_CARD_MAX)
+						MemCardBlocksVal = 0;
+					if (which_bg == BG_NONE)
+					{
+					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 50, SettingY(ListLoopIndex), "%-18s:%-4d%s", OptionStrings[ListLoopIndex], MEM_CARD_BLOCKS(MemCardBlocksVal), MemCardBlocksVal > 2 ? "Unstable" : "");
+					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 50, SettingY(ListLoopIndex+1), "%-18s:%-4s", OptionStrings[ListLoopIndex+1], (ncfg->Config & (NIN_CFG_MC_MULTI)) ? "On " : "Off");
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+					PrintFormat(MENU_SIZE, WHITE, MENU_POS_X + 50, SettingY(ListLoopIndex), "%-18s:%-4d%s", OptionStrings[ListLoopIndex], MEM_CARD_BLOCKS(MemCardBlocksVal), MemCardBlocksVal > 2 ? "Unstable" : "");
+					PrintFormat(MENU_SIZE, WHITE, MENU_POS_X + 50, SettingY(ListLoopIndex+1), "%-18s:%-4s", OptionStrings[ListLoopIndex+1], (ncfg->Config & (NIN_CFG_MC_MULTI)) ? "On " : "Off");
+					}						
+				}
+				ListLoopIndex+=2;
+				char vidWidth[10];
+				if(ncfg->VideoScale < 40 || ncfg->VideoScale > 120)
+				{
 					ncfg->VideoScale = 0;
 					snprintf(vidWidth, sizeof(vidWidth), "Auto");
-				}	
-				else
-					snprintf(vidWidth, sizeof(vidWidth), "%i", ncfg->VideoScale + 600);
-
-				char vidOffset[10];
-				if(ncfg->VideoOffset < -20 || ncfg->VideoOffset > 20)
-					ncfg->VideoOffset = 0;
-				snprintf(vidOffset, sizeof(vidOffset), "%i", ncfg->VideoOffset);
-
-				ListLoopIndex = 0; //reset on other side
-				PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 320, SettingY(ListLoopIndex), "%-18s:%-4s", "Video Width", vidWidth);
-				ListLoopIndex++;
+				}	
+				else
+					snprintf(vidWidth, sizeof(vidWidth), "%i", ncfg->VideoScale + 600);
+				char vidOffset[10];
+				if(ncfg->VideoOffset < -20 || ncfg->VideoOffset > 20)
+					ncfg->VideoOffset = 0;
+				snprintf(vidOffset, sizeof(vidOffset), "%i", ncfg->VideoOffset);	
+				if (which_bg == BG_NONE)
+				{				
+				ListLoopIndex = 0; //reset on other side
+				PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 320, SettingY(ListLoopIndex), "%-18s:%-4s", "Video Width", vidWidth);
+				ListLoopIndex++;
 				PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 320, SettingY(ListLoopIndex), "%-18s:%-4s", "Screen Position", vidOffset);
-				ListLoopIndex++;
-				PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 320, SettingY(ListLoopIndex), "%-18s:%-4s", "Patch PAL50", (ncfg->VideoMode & (NIN_VID_PATCH_PAL50)) ? "On " : "Off");
-				ListLoopIndex++;
-				if(settingPart == 0)
-					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 30, SettingY(PosX), ARROW_RIGHT);
-				else
-					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 300, SettingY(PosX), ARROW_RIGHT);
-				PrintInfo();
-				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*0, "Home: Go Back");
-				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "A   : %s", MenuMode ? "Modify" : "Select");
-				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*2, "B   : %s", MenuMode ? "Game List" : "Settings ");
-				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*3, MenuMode ? "X/1 : Update" : "");
-				if (devState == DEV_OK)
-				{
-					// FIXME: If devState != DEV_OK,
+				ListLoopIndex++;
+				PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 320, SettingY(ListLoopIndex), "%-18s:%-4s", "Patch PAL50", (ncfg->VideoMode & (NIN_VID_PATCH_PAL50)) ? "On " : "Off");
+				ListLoopIndex++;
+				}
+				else if (which_bg == BG_LEGACY)
+				{				
+				ListLoopIndex = 0; //reset on other side
+				PrintFormat(MENU_SIZE, WHITE, MENU_POS_X + 320, SettingY(ListLoopIndex), "%-18s:%-4s", "Video Width", vidWidth);
+				ListLoopIndex++;
+				PrintFormat(MENU_SIZE, WHITE, MENU_POS_X + 320, SettingY(ListLoopIndex), "%-18s:%-4s", "Screen Position", vidOffset);
+				ListLoopIndex++;
+				PrintFormat(MENU_SIZE, WHITE, MENU_POS_X + 320, SettingY(ListLoopIndex), "%-18s:%-4s", "Patch PAL50", (ncfg->VideoMode & (NIN_VID_PATCH_PAL50)) ? "On " : "Off");
+				ListLoopIndex++;
+				}
+				if(settingPart == 0) {
+				if (which_bg == BG_NONE){
+					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 30, SettingY(PosX), ARROW_RIGHT);}
+				else if (which_bg == BG_LEGACY){
+					PrintFormat(MENU_SIZE, WHITE, MENU_POS_X + 30, SettingY(PosX), ARROW_RIGHT);}}
+				else {
+				if (which_bg == BG_NONE){
+					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 300, SettingY(PosX), ARROW_RIGHT);}
+				else if (which_bg == BG_LEGACY){
+				PrintFormat(MENU_SIZE, WHITE, MENU_POS_X + 300, SettingY(PosX), ARROW_RIGHT);}}
+				PrintInfo();
+					if (which_bg == BG_NONE)
+					{
+				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y, "  Home: Device");
+				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : %s", MenuMode ? "Modify" : "Select");
+				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : %s", MenuMode ? "Game List" : "Settings ");
+				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*2, "X / 1 : Updates & Themes");
+				PrintFormat(15, BLACK, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+				PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y, "  Home: Device");
+				PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : %s", MenuMode ? "Modify" : "Select");
+				PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : %s", MenuMode ? "Game List" : "Settings ");
+				PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*2, "X / 1 : Updates & Themes");
+				PrintFormat(15, WHITE, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");
+					}
+				if (devState == DEV_OK)
+				{
+					// FIXME: If devState != DEV_OK,
 					// the device info overlaps with the settings menu.
 					PrintDevInfo();
 				}
@@ -884,13 +1098,17 @@
 				Screenshot();
 				ClearScreen();
 				redraw = 0;
-			}
-		}
-	}
-
-	u32 SelectedGame = PosX + ScrollX;
-	char* StartChar = gi[SelectedGame].Path + 3;
-	if (StartChar[0] == ':')
+			}
+		}
+	}
+	ExitBoot = 0;
+	//GRRLIB_FillScreen (BLACK);
+	ClearScreen();	
+	FadeOut();
+	GRRLIB_Render();
+	u32 SelectedGame = PosX + ScrollX;
+	char* StartChar = gi[SelectedGame].Path + 3;
+	if (StartChar[0] == ':')
 		StartChar++;
 	memcpy(ncfg->GamePath, StartChar, strlen(gi[SelectedGame].Path));
 	memcpy(&(ncfg->GameID), gi[SelectedGame].ID, 4);
@@ -906,55 +1124,92 @@
 
 	if (!selected)
 	{
-		// No game selected.
-		return 0;
-	}
-
-	// Game is selected.
-	// TODO: Return an enum.
-	return (SaveSettings ? 3 : 1);
+		// No game selected.
+		return 0;
+	}
+	
+	// Game is selected.
+	// TODO: Return an enum.
+	return (SaveSettings ? 3 : 1);
 }
 
 /**
- * Select the source device and game.
- * @return TRUE to save settings; FALSE if no settings have been changed.
- */
-bool SelectDevAndGame(void)
-{
-	// Select the source device. (SD or USB)
+ * Select the source device and game.
+ * @return TRUE to save settings; FALSE if no settings have been changed.
+ */
+ 
+bool SelectGameList(void)
+{
+		bool SaveSettings = false;
+	while (1)
+	{
+		if (ExitBoot == 1)
+		SelectGame();
+		else
+		SelectDevAndGame();	
+		break;
+	}
+	return SaveSettings;
+}
+
+bool SelectDevAndGame(void)
+{
+	// Select the source device. (SD or USB)
 	bool SaveSettings = false;
 	while (1)
-	{
-		VIDEO_WaitVSync();
-		FPAD_Update();
-
-		UseSD = (ncfg->Config & NIN_CFG_USB) == 0;
-		PrintInfo();
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*0, "Home: Exit");
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "A   : Select");
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 53 * 6 - 8, MENU_POS_Y + 20 * 6, UseSD ? ARROW_LEFT : "");
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 53 * 6 - 8, MENU_POS_Y + 20 * 7, UseSD ? "" : ARROW_LEFT);
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 47 * 6 - 8, MENU_POS_Y + 20 * 6, " SD  ");
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 47 * 6 - 8, MENU_POS_Y + 20 * 7, "USB  ");
-
-		// Render the screen here to prevent a blank frame
-		// when returning from SelectGame().
-		GRRLIB_Render();
-		ClearScreen();
-
-		if (FPAD_OK(0))
-		{
-			// Select a game from the specified device.
-			int ret = SelectGame();
-			if (ret & 2) SaveSettings = true;
-			if (ret & 1) break;
-		}
-		else if (FPAD_Start(0))
-		{
-			ShowMessageScreenAndExit("Returning to loader...", 0);
-		}
-		else if (FPAD_Down(0))
-		{
+	{
+		VIDEO_WaitVSync();
+		FPAD_Update();
+		
+		UseSD = (ncfg->Config & NIN_CFG_USB) == 0;
+		PrintInfo();
+						if (which_bg == BG_NONE)
+					{
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*0, "Home: Exit");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "A   : Select");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 53 * 6 - 8, MENU_POS_Y + 20 * 6, UseSD ? ARROW_LEFT : "");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 53 * 6 - 8, MENU_POS_Y + 20 * 7, UseSD ? "" : ARROW_LEFT);
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 47 * 6 - 8, MENU_POS_Y + 20 * 6, " SD  ");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 47 * 6 - 8, MENU_POS_Y + 20 * 7, "USB  ");
+		PrintFormat(15, BLACK, MENU_POS_X + 225, MENU_POS_Y + 20*21, "MASTERMOD\xc2\xa9MMXVI");
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*0, "Home: Exit");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*1, "A   : Select");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 53 * 6 - 8, MENU_POS_Y + 20 * 6, UseSD ? ARROW_LEFT : "");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 53 * 6 - 8, MENU_POS_Y + 20 * 7, UseSD ? "" : ARROW_LEFT);
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 47 * 6 - 8, MENU_POS_Y + 20 * 6, " SD  ");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 47 * 6 - 8, MENU_POS_Y + 20 * 7, "USB  ");
+		PrintFormat(15, WHITE, MENU_POS_X + 225, MENU_POS_Y + 20*21, "MASTERMOD\xc2\xa9MMXVI");
+					}	
+		// Render the screen here to prevent a blank frame
+		// when returning from SelectGame().
+		GRRLIB_Render();
+		ClearScreen();
+		
+		
+		if (FPAD_OK(0))
+		{
+			// Select a game from the specified device.
+			int ret = SelectGame();
+			if (ret & 2) 
+			SaveSettings = true;
+			if (ret & 1) 
+			break;
+			
+		}
+		else if (FPAD_Start(0))
+		{
+		//	ShowMessageScreenAndExit("Returning to loader...", 0);
+					if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, 212, 232, "Returning to loader...");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, 212, 232, "Returning to loader...");}
+					ExitToLoader(0);
+		}
+		else if (FPAD_Down(0))
+		{
 			ncfg->Config = ncfg->Config | NIN_CFG_USB;
 		}
 		else if (FPAD_Up(0))
@@ -974,14 +1229,21 @@
 {
 	const int len = strlen(msg);
 	const int x = (640 - (len*10)) / 2;
+
+	ClearScreen();
+	PrintInfo();
+					if (which_bg == BG_NONE)
+					{
+	PrintFormat(DEFAULT_SIZE, BLACK, x, 232, "%s", msg);
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+	PrintFormat(DEFAULT_SIZE, WHITE, x, 232, "%s", msg);
+					}		
+	GRRLIB_Render();
+	ClearScreen();
+}
 
-	ClearScreen();
-	PrintInfo();
-	PrintFormat(DEFAULT_SIZE, BLACK, x, 232, "%s", msg);
-	GRRLIB_Render();
-	ClearScreen();
-}
-
 /**
  * Show a single message screen and then exit to loader..
  * @param msg Message.
@@ -994,30 +1256,44 @@
 	const u32 color = (ret == 0 ? BLACK : MAROON);
 
 	ClearScreen();
-	PrintInfo();
-	PrintFormat(DEFAULT_SIZE, color, x, 232, "%s", msg);
-	ExitToLoader(ret);
-}
-
-/**
+	PrintInfo();
+	PrintFormat(DEFAULT_SIZE, color, x, 232, "%s", msg);
+	ExitToLoader(ret);
+
+}
+
+/**
  * Print Nintendont version and system hardware information.
- */
-void PrintInfo(void)
-{
-#ifdef NIN_SPECIAL_VERSION
-	// "Special" version with customizations. (Not mainline!)
-	PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*0, "Nintendont Loader v%u.%u" NIN_SPECIAL_VERSION " (%s)",
+ */
+void PrintInfo(void)
+{
+	if (which_bg == BG_NONE)
+	{
+#ifdef NIN_SPECIAL_VERSION
+	// "Special" version with customizations. (Not mainline!)
+	PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*0, "Nintendont Loader v%u.%u" NIN_SPECIAL_VERSION " (%s)",
 		    NIN_VERSION>>16, NIN_VERSION&0xFFFF, IsWiiU() ? "Wii U" : "Wii");
 #else
 	PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*0, "Nintendont Loader v%u.%u (%s)",
-		    NIN_VERSION>>16, NIN_VERSION&0xFFFF, IsWiiU() ? "Wii U" : "Wii");
-#endif
-	PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*1, "Built   : " __DATE__ " " __TIME__);
-	PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*2, "Firmware: %u.%u.%u",
-		    *(vu16*)0x80003140, *(vu8*)0x80003142, *(vu8*)0x80003143);
-}
-
-/**
+		    NIN_VERSION>>16, NIN_VERSION&0xFFFF, IsWiiU() ? "Wii U" : "Wii");
+#endif
+	PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*1, "Built   : " __DATE__ " " __TIME__);
+	}
+	else if (which_bg == BG_LEGACY)
+	{
+#ifdef NIN_SPECIAL_VERSION
+	// "Special" version with customizations. (Not mainline!)
+	PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*0, "Nintendont Loader v%u.%u" NIN_SPECIAL_VERSION " (%s)",
+		    NIN_VERSION>>16, NIN_VERSION&0xFFFF, IsWiiU() ? "Wii U" : "Wii");
+#else
+	PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*0, "Nintendont Loader v%u.%u (%s)",
+		    NIN_VERSION>>16, NIN_VERSION&0xFFFF, IsWiiU() ? "Wii U" : "Wii");
+#endif
+	PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*1, "Built   : " __DATE__ " " __TIME__);
+	}
+}
+
+/**
  * Print information about the selected device.
  */
 static void PrintDevInfo(void)
